Name:          ohc
Version:       0.4.2
Release:       3%{?dist}
Summary:       Java large off heap cache 
License:       ASL 2.0
URL:           http://caffinitas.org/
Source0:       https://github.com/snazy/%{name}/archive/%{version}.tar.gz

BuildRequires: maven-local
BuildRequires: mvn(com.google.guava:guava)
BuildRequires: mvn(commons-cli:commons-cli)

# change to dropwizard for fedora 24
#BuildRequires: mvn(io.dropwizard.metrics:metrics-core)
BuildRequires: mvn(com.codahale.metrics:metrics-core)

BuildRequires: mvn(net.java.dev.jna:jna)
BuildRequires: mvn(net.jpountz.lz4:lz4)
BuildRequires: mvn(org.apache.commons:commons-math3)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.logging.log4j:log4j-api)
BuildRequires: mvn(org.apache.logging.log4j:log4j-core)
BuildRequires: mvn(org.apache.logging.log4j:log4j-slf4j-impl)
BuildRequires: mvn(org.openjdk.jmh:jmh-core)
BuildRequires: mvn(org.openjdk.jmh:jmh-generator-annprocess)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.testng:testng)
BuildRequires: mvn(org.xerial.snappy:snappy-java)
# missing in tests
BuildRequires: mvn(org.codehaus.mojo:exec-maven-plugin)

BuildArch:     noarch

%description
OHC - Off-Heap Concurrent hash map intended to store GBs of serialized data.

%package benchmark
Summary:       OHC benchmark executable

%description benchmark
OHC benchmark executable.

%package core-j8
Summary:       OHC core - Java8 optimization

%description core-j8
OHC core - Java8 optimization.

%package jmh
Summary:       OHC core - micro benchmarks

%description jmh
Off-Heap concurrent hash map intended to store GBs of serialized data.

%package parent
Summary:       OHC Parent POM

%description parent
OHC Parent POM.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{version}

%pom_remove_plugin -r :cobertura-maven-plugin
%pom_remove_plugin -r :maven-assembly-plugin
%pom_remove_plugin -r :maven-dependency-plugin
%pom_remove_plugin -r :maven-javadoc-plugin
%pom_remove_plugin -r :maven-shade-plugin
%pom_remove_plugin -r :maven-source-plugin

%pom_xpath_set -r "pom:addClasspath" false
%pom_xpath_remove -r "pom:classpathPrefix"

#remove for fedora24
%pom_remove_dep io.dropwizard.metrics:metrics-core %{name}-benchmark
%pom_add_dep com.codahale.metrics:metrics-core %{name}-benchmark

# prepare scripts that will be installed
sed -i 's/jar=.*$/jar=\/usr\/share\/java\/%{name}\/%{name}-benchmark.jar/g' %{name}-benchmark/src/main/sh/batch-bench.sh
sed -i 's/java $jvm_arg -jar $jar "/`which java` $jvm_arg -cp $jar org.caffinitas.%{name}.benchmark.BenchmarkOHC "/g' %{name}-benchmark/src/main/sh/batch-bench.sh

%build
%mvn_build -fs

%install
%mvn_install
%jpackage_script org.caffinitas.%{name}.benchmark.BenchmarkOHC "" "" %{name}-core BenchmarkOHC true
chmod 755 %{name}-benchmark/src/main/sh/batch-bench.sh
cp %{name}-benchmark/src/main/sh/batch-bench.sh	%{buildroot}%{_bindir}/%{name}-batch-bench
chmod 755 %{name}-benchmark/src/main/sh/consolidate-output.sh 
cp %{name}-benchmark/src/main/sh/consolidate-output.sh	%{buildroot}%{_bindir}/%{name}-consolidate-output

%files -f .mfiles-%{name}-core
%doc CHANGES.txt README.rst notes-todos.txt
%license %{name}-core/LICENSE.txt

%files benchmark -f .mfiles-%{name}-benchmark
%doc %{name}-benchmark/NOTES.txt
%license %{name}-benchmark/LICENSE.txt
%{_bindir}/BenchmarkOHC
%{_bindir}/%{name}-batch-bench
%{_bindir}/%{name}-consolidate-output

%files core-j8 -f .mfiles-%{name}-core-j8
%license %{name}-core-j8/LICENSE.txt

%files jmh -f .mfiles-%{name}-jmh
%license %{name}-jmh/LICENSE.txt

%files parent -f .mfiles-%{name}-parent
%license LICENSE.txt

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt

%changelog
* Wed Mar 16 2016 Tomas Repik <trepik@redhat.com> - 0.4.2-3
- launcher BenchmarkOHC installation
- benchmark scrips added

* Fri Feb 12 2016 Tomas Repik <trepik@redhat.com> - 0.4.2-2
- Updated build-dependencies

* Sat Feb 06 2016 gil cattaneo <puntogil@libero.it> 0.4.2-1
- update to 0.4.2

* Wed Jul 22 2015 gil cattaneo <puntogil@libero.it> 0.3.6-1
- initial rpm
